/// <reference types="react" />
import { Option } from 'fp-ts/lib/Option';
import { TPopoverProps } from '../Popover/Popover';
import { TButtonIconProps } from '../ButtonIcon/ButtonIcon';
import { TControlProps } from '../Control/Control';
import { TSteppableInputProps } from '../SteppableInput/SteppableInput';
export declare type TDateInputValue = {
    day: Option<number>;
    month: Option<number>;
    year: Option<number>;
};
export declare const isDatesDifferent: (x: TDateInputValue, y: TDateInputValue) => boolean;
export declare const buildDateOption: import("fp-ts/lib/function").Curried3<Option<number>, Option<number>, Option<number>, Option<Date>>;
export declare enum DateFormatType {
    MDY = 0,
    DMY = 1
}
export declare type TCalendarProps = TControlProps<Date | null> & {
    onMouseDown?: React.EventHandler<React.MouseEvent<Element>>;
    min?: Date;
    max?: Date;
};
declare type TDateValueProps = TControlProps<TDateInputValue>;
export declare type TDateInputOwnProps = TSteppableInputProps & TDateValueProps & {
    min?: Date;
    max?: Date;
    calendarIcon?: React.ReactElement<any>;
    onClear?: Function;
    onFocus?: () => void;
    onBlur?: () => void;
    target?: Element;
    Calendar?: React.ComponentClass<TCalendarProps> | React.SFC<TCalendarProps>;
};
declare type TDateDefaultProps = {
    SteppableInput: React.ComponentClass<TSteppableInputProps> | React.SFC<TSteppableInputProps>;
    ButtonIcon: React.ComponentClass<TButtonIconProps>;
    Popover: React.ComponentClass<TPopoverProps> | React.SFC<TPopoverProps>;
    dateFormatType: DateFormatType;
};
export declare type TDateInputInjectedProps = {
    theme: {
        inner?: string;
        inner_isFilled?: string;
        section?: string;
        section_isActive?: string;
        separator?: string;
        SteppableInput?: TSteppableInputProps['theme'];
        ButtonIcon?: TButtonIconProps['theme'];
        CalendarButtonIcon?: TButtonIconProps['theme'];
        Popover?: TPopoverProps['theme'];
    };
};
export declare type TDateInputFullProps = TDateInputOwnProps & TDateInputInjectedProps & TDateDefaultProps;
export declare type TDateInputState = {
    activeSection?: ActiveSection;
    isOpened?: boolean;
};
export declare enum ActiveSection {
    Day = 0,
    Month = 1,
    Year = 2
}
export declare const toObjectDate: (date: Date) => TDateInputValue;
export declare function format(date: Option<number>, section: ActiveSection): string;
export {};
